#include <Servo.h>                                                            // подключаем библеотеку сервопривода



// Основные константы:
#define M1S 6 // Левый мотор
#define M2S 11 // Правый мотор
#define S2 analogRead(A6) 
#define S3 analogRead(A7) 
#define Sen2 map(S2,253,430,0,100) 
#define Sen3 map(S3,33,115,0,100) 

// Переменные для PD-регулятора:
float Kp = 0.4; //Пропорцирнальный
float Kd = 0; // Дифференциальный
int lastError = 0; //Прошлая ошибка

void driveBC(int MB, int MC) { 
  analogWrite(M1S, map(constrain(abs(MB), 0, 100), 0, 100, 0, 255));
  analogWrite(M2S, map(constrain(abs(MC), 0, 100), 0, 100, 0, 255));
}

float PDreg(int par1, int par2) { // Одна итерация PD-регулятора
  int error = par1 - par2; // Ошибка
  float P = error * Kp; // Пропорциональная состовляющая
  float D = (error - lastError) * Kd; // Дифференциальная составляющая
  lastError = error; //Обновление прошлой ошибки
  return P + D; // Сумма состовляющих
}

void line_millis(int t, int V) { 
  long tStart = millis();
  while (millis() - tStart < t) { 
    float UV = PDreg(Sen2, Sen3); 
    driveBC(V + UV, V - UV);
    delay(5); 
  }
}

Servo myservo;                                                                // создаем объект сервопривода

void setup() {
  Serial.begin(9600);                                                         // открываем порт для вывода значений

  pinMode(6, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(2, INPUT_PULLUP);                                                   // Устанавливает режим работы кнопки - вход с подтяжкой
  myservo.attach(3);                                                          // прикрепляет сервопривод к контакту 3
  int z = 40, x = 90;
  myservo.write(0);                                                           // возращаем сервопривод в 0 положение

  while (digitalRead(2) == 1) {                                               // ждем пока кнопка не нажата
    Serial.println("|S2: " + String(S2) + "|S3:  " + String(S3) + "|Sen2: " + String(Sen2) + "|Sen3: " + String(Sen3));
    
  }
  digitalWrite(5, 0);
  digitalWrite(9, 0);
  line_millis(20000,50);
  myservo.write(40);  
  line_millis(30000,50);
  myservo.write(z);  
  line_millis(40000,50);
  driveBC(0,0);
  
}

void loop() {
  //float UV = PDreg(Sen2, Sen3); // Управляющее воздействие
  //driveBC(50 + UV, 50 - UV); // Подача расчётного напряжения
  //delay(5); // Небольшая задержка для верной работы дифференциальной составляющей
}